package com.factory.web.entity.excel;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFColor;
import org.apache.poi.xssf.usermodel.XSSFFont;

import java.awt.*;

public class Utility {

    /**
     * 设置单元格样式
     *
     * @param wb
     * @param isTitle
     * @return
     */
    public static XSSFCellStyle getTitleCellStyle(Workbook wb) {
        XSSFCellStyle cellStyle = (XSSFCellStyle) wb.createCellStyle();
        XSSFFont font = (XSSFFont) wb.createFont();
        font.setFontHeightInPoints((short) 10);
        cellStyle.setFont(font);//选择需要用到的字体格式
        cellStyle.setWrapText(true);
        //设置边框:
        cellStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
        cellStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
        cellStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
        cellStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);//右边框
        //设置居中:
        cellStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER); // 居中
        cellStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);

        return cellStyle;
    }

    public static XSSFCellStyle getTitleCellStyle(Workbook wb, short fontSize) {
        XSSFCellStyle cellStyle = (XSSFCellStyle) wb.createCellStyle();

        XSSFFont font = (XSSFFont) wb.createFont();
        font.setFontHeightInPoints((short) fontSize);
        cellStyle.setFont(font);//选择需要用到的字体格式

        cellStyle.setWrapText(true);
        //设置边框:
        cellStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
        cellStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
        cellStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
        cellStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);//右边框
        //设置居中:
        cellStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER); // 居中
        cellStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);

        return cellStyle;
    }

    public static XSSFCellStyle getTitleCellLeftStyle(Workbook wb, short fontSize) {
        XSSFCellStyle cellStyle = (XSSFCellStyle) wb.createCellStyle();

        XSSFFont font = (XSSFFont) wb.createFont();
        font.setFontHeightInPoints((short) fontSize);
        cellStyle.setFont(font);//选择需要用到的字体格式

        cellStyle.setWrapText(true);
        //设置边框:
        cellStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
        cellStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
        cellStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
        cellStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);//右边框
        //设置居中:
        cellStyle.setAlignment(HSSFCellStyle.ALIGN_LEFT); // 左边
        cellStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);

        return cellStyle;
    }


    public static Sheet createSheet(Workbook wb, String name) {
        Sheet sheet = wb.createSheet(name);
        return sheet;
    }


    public static void addCellValForStr(Cell cell, String value, XSSFCellStyle style) {
        cell.setCellValue(value != null ? value : "");
        cell.setCellStyle(style);
    }


}
