package com.factory.web.entity.fa.req;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 日周月点检规则
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleCalendarReq {

	@ApiModelProperty(value = "日巡检开始时间 格式11:00")
	private String startDay;

	@ApiModelProperty(value = "日巡检结束时间 格式11:00")
	private String endDay;

	@ApiModelProperty(value = "日检查时长设置单位分钟 例如60")
	private Integer dayValidate;
	
	@ApiModelProperty(value = "升级时长设置单位是分钟 例如60 这个时间其实是汇报超时给监督")
	private Integer dayOuttime;

	@ApiModelProperty(value = "200件最晚提交时间")
	private String twoHundredSubmitTime;

	@ApiModelProperty(value = "点检人对应的用户ID")
	private Long userId;
	
	@ApiModelProperty(value = "0表示首件 1表示200件")
	private Integer typeFlag;

}
