package com.factory.wx.service;

import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.po.benteler.BentelerPlan;
import com.factory.wx.entity.req.PlanApprovalTaskReq;
import com.factory.wx.entity.req.PlanInfoReq;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.res.PlanPassDetailRes;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-13 12:13 下午
 */
public interface PlanPassService {

    /**
     * 计划放行列表
     *
     * @param planPageReq
     * @return
     */
    PageBean<BentelerPlan> getPassListByPage(PlanPageReq planPageReq);

    /**
     * 计划放行详情
     *
     * @param planInfoReq
     * @return
     */
    PlanPassDetailRes getPassDetail(PlanInfoReq planInfoReq);

    /**
     * 计划放行
     *
     * @param planApprovalTaskReq
     * @return
     */
    ResponseBean approvalTaskOperate(PlanApprovalTaskReq planApprovalTaskReq);

}
